package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.excel.QfExcel;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelQFListener;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-18
 */
@RestController
@RequestMapping("/dmQfxq")
public class DmQfxqController {

    @Autowired
    DmQfxqService service;
    @Autowired
    DmCbxxpService cbxxpService;
    //查询
    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmQfxq qfxq){
       List<DmQfxq>  list=service.list(new QueryWrapper<DmQfxq>()
                               .eq(StrUtil.isNotEmpty(qfxq.getDcCh()),"DC_CH",qfxq.getDcCh())
                               .eq(StrUtil.isNotEmpty(qfxq.getZt()),"zt",qfxq.getZt())
                               .eq(StrUtil.isNotEmpty(qfxq.getDcPl()),"DC_PL",qfxq.getDcPl()));
        return new ResultBean(list);
    }

    @RequestMapping("/getCzxx")
    @AuthFunction
    public ResultBean getCzxx(){
       List<DmCbxxp> list= cbxxpService.list(new QueryWrapper<DmCbxxp>()
               .select("cbbm","cbmc")
               .eq("wgbs","N")
               .orderBy(true, true, "cbbm"));
        return new ResultBean(list);
    }
    //导入
    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadQf(@RequestParam("file") MultipartFile file , String czbh, HttpServletRequest req) throws Exception, CustomException {

        ExcelQFListener objectListener = new ExcelQFListener();
        EasyExcel.read(file.getInputStream(), QfExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<QfExcel> objList = objectListener.getObjectList();
        service.uploadQf(objList,czbh,req);
        return new ResultBean();
    }

    //保存
    @RequestMapping("/save")
    @AuthFunction
    public ResultBean save(@RequestBody List<DmQfxq> qfxqs){
        service.saveBatch(qfxqs);
        return new ResultBean();
    }
    //删除
    @RequestMapping("/remove")
    @AuthFunction
    public ResultBean remove(@RequestBody List<DmQfxq> qfxqs){
        service.removeByIds(qfxqs);
        return new ResultBean();
    }
    //提交/退回
    @RequestMapping("/qfxqTJ")
    @AuthFunction
    public ResultBean qfxqTJ(@RequestBody List<DmQfxq> qfxqs){
        qfxqs.forEach(q->{
            if (q.getZt().equals("0")) {
                     q.setZt("1");
                     return;
            }
            if (q.getZt().equals("1")){
                q.setZt("0");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }
    //审核
    @RequestMapping("/qfxqSH")
    @AuthFunction
    public ResultBean qfxqSH(@RequestBody List<DmQfxq> qfxqs){
        qfxqs.forEach(q->{
            if (q.getZt().equals("1")) {
                q.setZt("2");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }


}
