package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.sy.SYService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@RestController
@RequestMapping("/dmSygdMx")
public class DmSygdMxController {

    @Autowired
    private DmSygdMxService service;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmSygdMx sygd){
       List<DmSygdMx> list= service.list(new QueryWrapper<DmSygdMx>()
               .eq(StrUtil.isNotEmpty(sygd.getDcCh()),"dc_ch",sygd.getDcCh())
               .eq(StrUtil.isNotEmpty(sygd.getDcPl()),"dc_pl",sygd.getDcPl())
               .ge(StrUtil.isNotEmpty(sygd.getBeginTime()),"jssj",sygd.getBeginTime())
               .le(StrUtil.isNotEmpty(sygd.getEndTime()),"jssj",sygd.getEndTime())
                       .orderByAsc("dc_ch,dc_pl,jssj")
                );
        return new ResultBean(list);
    }
    @RequestMapping("/sygdPC")
    @AuthFunction
    public ResultBean sygdPC(){
        return new ResultBean(service.sygdPC());
    }

    @RequestMapping("/saveByDcch")
    @AuthFunction
    public ResultBean saveByDcch(@RequestBody HashMap<String, List<Object>> map ){
        return new ResultBean(service.saveByDcch(map));
    }

    @RequestMapping("/getKwList")
    @AuthFunction
    public ResultBean getKwList(@RequestBody List<DmSygdMx> list ){
        return new ResultBean(service.getKwList(list));
    }

    @RequestMapping("/tqSygd")
    @AuthFunction
    public ResultBean tqSygd( ){
        return service.tqSygd();
    }

    public static void main(String[] agrs){
//        String[] a={"序号","产品","批量","分段","板数","上料","型材抛丸","抛丸","一垮龙门板数","一垮数控板数","坡口切割结束","二垮数控板数","数控切割开始","坡口切割结束","三垮数控板数","数控切割开始","坡口切割结束","三垮平铁板数","平铁切割开始","平铁切割结束","曲平铁转结束","曲平铁结束","曲外板结束","组立","数控   板数","数控切割开始","坡口切割结束","面板挤边","七垮型  材米数","型材  面板","小组配送结束","光电  结束","备注"};
//        String[] a={"船名","批量","图名","科室","套料图下发","套料图生产需求期","套料图接收","板材领取表下发","板材领取表生产需求期","板材领取表接收","零件配套表下发","零件配套表生产需求期","零件配套表接收"};
//        String[] a={"船号","订货清单号","期次","需求日期","实际到货日期","物料号","材质MATERIAL","厚度THICK.mm","宽度WIDTHmm","长度LENGTHmm","重量吨/张WEIGHTTON/PIECE","设计数量张DESIGNPIECE","裕量张MARGINPIECE","总数量张TOTALPIECE","总重量吨TOTALTON ","利库数量张STOREPIECE","利库重量吨STORETON","实订数量张ORDERPIECE","实订重量吨ORDERTON","备注NOTE"};
//        for (int i = 0; i < a.length; i++) {
//            System.out.println("{ field: '', title: '"+a[i]+"', width: 120, editRender: { name: 'input' },\n" +
//                    " filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],\n" +
//                    " filterRender: { name: 'FilterCombination', },\n" +
//                    " },");
//        }

    }
}

